.486 
.model flat,stdcall 
option casemap:none 

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm
include \masm32\include\msvcrt.inc
include \masm32\include\Fpu.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\msvcrt.lib
includelib \masm32\lib\Fpu.lib

GetAbsoluteXCoords proto :DWORD, :DWORD, :DWORD, :DWORD
GetCoefficientOfXSquared proto :DWORD, :DWORD, :SDWORD
CalculateCoords proto :DWORD, :DWORD

.data

DriverName      db      "DISPLAY",0
ConsoleTitle    db      "Drawing A Parabola",0
xCalcWidth      dword   5

.data?

hSTD            dword   ?
hDC             dword   ?
hPen            dword   ?
StartPointX     dword   ?
StartPointY     dword   ?
EndPointX       dword   ?
EndPointY       dword   ?
LevelX          dword   ?

PointArray      dword   2000 dup (?)

QuadraticA      tbyte   ?
QuadraticB      tbyte   ?
CalculatedY     tbyte   ?
RoundedX        dword   ?
RoundedY        dword   ?
AbsoluteX       dword   ?
Coefficient1    tbyte   ?
Coefficient2    tbyte   ?
AbsoluteX1      dword   ?
AbsoluteX2      dword   ?
x1_1            tbyte   ?
x2_1            tbyte   ?
x1_2            tbyte   ?
x2_2            tbyte   ?
Roundedx1_1     dword   ?
Roundedx2_1     dword   ?
Roundedx1_2     dword   ?
Roundedx2_2     dword   ?
ParabolaLen     dword   ?
xTSquared       dword   ?

CxScreen    dword   ?
CyScreen    dword   ?

.code
    Start:

xor ebx, ebx
    invoke AllocConsole
    invoke SetConsoleTitle, addr ConsoleTitle
    invoke GetStdHandle, STD_OUTPUT_HANDLE
mov hSTD, eax

    invoke SetConsoleTextAttribute, hSTD, FOREGROUND_RED OR FOREGROUND_INTENSITY

            print "    ======================================================================", 13, 10
            print "                 Coded in MASM32 by Mike of ********.net", 13, 10
            print "    ======================================================================", 13, 10, 13, 10, 13, 10, 9, 9
            print "================ HOTKEYS ================", 13, 10, 13, 10, 9, 9
            print "F8       =   Start position", 13, 10, 9, 9
            print "F9       =   End position", 13, 10, 9, 9
            print "F10      =   Close app", 13, 10, 13, 10
            print "Place mouse at desired start position and hit F8 once.  Move mouse to end", 13, 10
            print "position and hit F9 once.  Once it starts drawing you can hit F10 to close the app", 13, 10, 13, 10, 13, 10

    invoke SetConsoleTextAttribute, hSTD, FOREGROUND_GREEN OR FOREGROUND_INTENSITY
    invoke CreateDC, addr DriverName, ebx, ebx, ebx
mov hDC, eax
    invoke CreatePen, PS_DASHDOTDOT, 1, 000000ffh
mov hPen, eax
    invoke SelectObject, hDC, eax
    invoke GetSystemMetrics, SM_CXSCREEN
mov CxScreen, eax
                print "Full screen X = "
                print str$(CxScreen), 13, 10
    invoke GetSystemMetrics, SM_CYSCREEN
mov CyScreen, eax
                print "Full screen Y = "
                print str$(CyScreen), 13, 10, 13, 10

    invoke SetConsoleTextAttribute, hSTD, FOREGROUND_BLUE OR FOREGROUND_INTENSITY

@@:

    invoke Sleep, 1
    invoke GetAsyncKeyState, VK_F8
test eax, eax
jz @b

    invoke GetCursorPos, addr StartPointX

@@:

    invoke Sleep, 1
    invoke GetAsyncKeyState, VK_F9
test eax, eax
jz @b

    invoke GetCursorPos, addr EndPointX

            print "StartPointX : "
            print str$(StartPointX), 13, 10
            print "StartPointY : "
            print str$(StartPointY), 13, 10
            print "EndPointX : "
            print str$(EndPointX), 13, 10
            print "EndPointY : "
            print str$(EndPointY), 13, 10, 13, 10

mov eax, EndPointX
sub eax, StartPointX
mov ParabolaLen, eax
invoke IntMul, ParabolaLen, ParabolaLen
mov xTSquared, eax

    invoke GetCoefficientOfXSquared, StartPointY, EndPointY, eax
    invoke GetAbsoluteXCoords, StartPointY, EndPointY, addr Coefficient1, addr Coefficient2

mov edi, -1
mov esi, StartPointX
sub esi, xCalcWidth

@@:

inc edi
add esi, xCalcWidth
mov PointArray[edi*8], esi

    invoke Sleep, 1
    invoke CalculateCoords, addr Coefficient1, Roundedx1_1
    invoke FpuRound, addr CalculatedY, addr RoundedY, SRC1_REAL OR DEST_IMEM
mov eax, RoundedY
mov PointArray[edi*8+4], eax

cmp eax, CyScreen
jae @f

mov eax, xCalcWidth
add Roundedx1_1, eax

cmp esi, CxScreen
jb @b
test esi, esi
jnz @b

@@:

    invoke Sleep, 1
    invoke Polyline, hDC, addr PointArray, edi
    invoke GetAsyncKeyState, VK_F10
test eax, eax
jz @b

    invoke FreeConsole
    invoke DeleteObject, hPen
    invoke DeleteDC, hDC
    invoke ExitProcess, ebx

CalculateCoords proc lpA:DWORD, CalcX:DWORD
LOCAL XSquared:DWORD

    invoke IntMul, CalcX, CalcX
mov XSquared, eax
    invoke FpuMul, addr XSquared, lpA, addr CalculatedY, SRC1_DMEM OR SRC2_REAL

ret
CalculateCoords endp

GetCoefficientOfXSquared proc y1:DWORD, y2:DWORD, _xTSquared:SDWORD
LOCAL Numerator1:TBYTE
LOCAL WorkingValue1:TBYTE

LOCAL WorkingValue2:TBYTE

LOCAL Numerator3:DWORD
LOCAL WorkingValue3:TBYTE

LOCAL ContentsOfSqRt:TBYTE
LOCAL ResultOfSqRt:TBYTE

            print "xT^2 : "
            print str$(_xTSquared), 13, 10

    invoke FpuAdd, y1, y2, addr Numerator1, SRC1_DIMM OR SRC2_DIMM

            print "Numerator1 : "
            print real10$(Numerator1), 13, 10

    invoke FpuDiv, addr Numerator1, _xTSquared, addr WorkingValue1, SRC1_REAL OR SRC2_DIMM

            print "Working value 1 : "
            print real10$(WorkingValue1), 13, 10

    invoke FpuMul, addr WorkingValue1, addr WorkingValue1, addr WorkingValue2, SRC1_REAL OR SRC2_REAL

            print "Working value 2 : "
            print real10$(WorkingValue2), 13, 10

    invoke FpuSub, y1, y2, addr Numerator3, SRC1_DIMM OR SRC2_DIMM
    invoke FpuDiv, addr Numerator3, _xTSquared, addr WorkingValue3, SRC1_REAL OR SRC2_DIMM
    invoke FpuMul, addr WorkingValue3, addr WorkingValue3, addr WorkingValue3, SRC1_REAL OR SRC2_REAL

            print "Working value 3 : "
            print real10$(WorkingValue3), 13, 10, 13, 10

    invoke FpuSub, addr WorkingValue2, addr WorkingValue3, addr ContentsOfSqRt, SRC1_REAL OR SRC2_REAL

            print "Contents of square root : "
            print real10$(ContentsOfSqRt), 13, 10

    invoke FpuSqrt, addr ContentsOfSqRt, addr ResultOfSqRt, SRC1_REAL

            print "Result of square root : "
            print real10$(ResultOfSqRt), 13, 10, 13, 10

    invoke FpuAdd, addr WorkingValue1, addr ResultOfSqRt, addr Coefficient1, SRC1_REAL OR SRC2_REAL
    invoke FpuSub, addr WorkingValue1, addr ResultOfSqRt, addr Coefficient2, SRC1_REAL OR SRC2_REAL
    
            print "Coefficient 1 : "
            print real10$(Coefficient1), 13, 10

            print "Coefficient 2 : "
            print real10$(Coefficient2), 13, 10, 13, 10

ret
GetCoefficientOfXSquared endp

GetAbsoluteXCoords proc y1:DWORD, y2:DWORD, lpCoefficient1:DWORD, lpCoefficient2:DWORD
LOCAL ContentsOfSqRt:TBYTE

    invoke FpuDiv, y1, lpCoefficient1, addr ContentsOfSqRt, SRC1_DIMM OR SRC2_REAL
    invoke FpuSqrt, addr ContentsOfSqRt, addr x1_1, SRC1_REAL
    invoke FpuChs, addr x1_1, addr x1_1, SRC1_REAL

            print "x1 from coefficient 1 : "
            print real10$(x1_1), 13, 10

    invoke FpuDiv, y2, lpCoefficient1, addr ContentsOfSqRt, SRC1_DIMM OR SRC2_REAL
    invoke FpuSqrt, addr ContentsOfSqRt, addr x2_1, SRC1_REAL

            print "x2 from coefficient 1 : "
            print real10$(x2_1), 13, 10, 13, 10

    invoke FpuDiv, y1, lpCoefficient2, addr ContentsOfSqRt, SRC1_DIMM OR SRC2_REAL
    invoke FpuSqrt, addr ContentsOfSqRt, addr x1_2, SRC1_REAL

            print "x1 from coefficient 2 : "
            print real10$(x1_2), 13, 10
            
    invoke FpuDiv, y2, lpCoefficient2, addr ContentsOfSqRt, SRC1_DIMM OR SRC2_REAL
    invoke FpuSqrt, addr ContentsOfSqRt, addr x2_2, SRC1_REAL

            print "x2 from coefficient 2 : "
            print real10$(x2_2), 13, 10

    invoke FpuRound, addr x1_1, addr Roundedx1_1, SRC1_REAL OR DEST_IMEM
    invoke FpuRound, addr x2_1, addr Roundedx2_1, SRC1_REAL OR DEST_IMEM
    invoke FpuRound, addr x1_2, addr Roundedx1_2, SRC1_REAL OR DEST_IMEM
    invoke FpuRound, addr x2_2, addr Roundedx2_2, SRC1_REAL OR DEST_IMEM

ret
GetAbsoluteXCoords endp

    end Start